/*
 * Copyright (C) 2020 Zebediah Figura for CodeWeavers
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef _WDFCHILDLIST_H_
#define _WDFCHILDLIST_H_

typedef struct _WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER
{
    ULONG IdentificationDescriptionSize;
} WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER, *PWDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER;

typedef struct _WDF_CHILD_ADDRESS_DESCRIPTION_HEADER
{
    ULONG AddressDescriptionSize;
} WDF_CHILD_ADDRESS_DESCRIPTION_HEADER, *PWDF_CHILD_ADDRESS_DESCRIPTION_HEADER;

typedef void (WINAPI *PFN_WDF_CHILD_LIST_ADDRESS_DESCRIPTION_CLEANUP)(WDFCHILDLIST list, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *desc);
typedef void (WINAPI *PFN_WDF_CHILD_LIST_ADDRESS_DESCRIPTION_COPY)(WDFCHILDLIST list, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *desc1, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *desc2);
typedef NTSTATUS (WINAPI *PFN_WDF_CHILD_LIST_ADDRESS_DESCRIPTION_DUPLICATE)(WDFCHILDLIST list, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *src, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *dst);
typedef NTSTATUS (WINAPI *PFN_WDF_CHILD_LIST_CREATE_DEVICE)(WDFCHILDLIST list, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *desc, PWDFDEVICE_INIT init);
typedef BOOLEAN (WINAPI *PFN_WDF_CHILD_LIST_DEVICE_REENUMERATED)(WDFCHILDLIST list, WDFDEVICE device, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *old_addr, WDF_CHILD_ADDRESS_DESCRIPTION_HEADER *new_addr);
typedef void (WINAPI *PFN_WDF_CHILD_LIST_SCAN_FOR_CHILDREN)(WDFCHILDLIST list);
typedef void (WINAPI *PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_CLEANUP)(WDFCHILDLIST list, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *desc);
typedef void (WINAPI *PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_COPY)(WDFCHILDLIST list, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *desc1, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *desc2);
typedef BOOLEAN (WINAPI *PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_COMPARE)(WDFCHILDLIST list, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *src, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *dst);
typedef NTSTATUS (WINAPI *PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_DUPLICATE)(WDFCHILDLIST list, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *src, WDF_CHILD_IDENTIFICATION_DESCRIPTION_HEADER *dst);

typedef struct _WDF_CHILD_LIST_CONFIG
{
    ULONG Size;
    ULONG IdentificationDescriptionSize;
    ULONG AddressDescriptionSize;
    PFN_WDF_CHILD_LIST_CREATE_DEVICE EvtChildListCreateDevice;
    PFN_WDF_CHILD_LIST_SCAN_FOR_CHILDREN EvtChildListScanForChildren;
    PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_COPY EvtChildListIdentificationDescriptionCopy;
    PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_DUPLICATE EvtChildListIdentificationDescriptionDuplicate;
    PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_CLEANUP EvtChildListIdentificationDescriptionCleanup;
    PFN_WDF_CHILD_LIST_IDENTIFICATION_DESCRIPTION_COMPARE EvtChildListIdentificationDescriptionCompare;
    PFN_WDF_CHILD_LIST_ADDRESS_DESCRIPTION_COPY EvtChildListAddressDescriptionCopy;
    PFN_WDF_CHILD_LIST_ADDRESS_DESCRIPTION_DUPLICATE EvtChildListAddressDescriptionDuplicate;
    PFN_WDF_CHILD_LIST_ADDRESS_DESCRIPTION_CLEANUP EvtChildListAddressDescriptionCleanup;
    PFN_WDF_CHILD_LIST_DEVICE_REENUMERATED EvtChildListDeviceReenumerated;
} WDF_CHILD_LIST_CONFIG, *PWDF_CHILD_LIST_CONFIG;

#endif
